MobDataAccesser = {}

function MobDataAccesser.GetMobData( MobID )
	local MobState = ActorStatus.New()
	
	MobState.Name		= MobDataAccesser.GetParam(M_V_NAME,			MobID)
	MobState.Lv			= MobDataAccesser.GetParam(M_V_LV,				MobID)
	MobState.MaxHP	= MobDataAccesser.GetParam(M_V_MAXHP,		MobID)
	MobState.MaxSP	= 0
	MobState.HP			= MobState.MaxHP
	MobState.SP			= 0
	
	MobState.AtkMax	= MobDataAccesser.GetParam(M_V_ATKMAX,	MobID)
	MobState.AtkMin	= MobDataAccesser.GetParam(M_V_ATKMIN,		MobID)
	MobState.DefDiv		= MobDataAccesser.GetParam(M_V_DEFDIV,		MobID)
	MobState.DefSub	= MobDataAccesser.GetParam(M_V_DEFSUB,		MobID)
	MobState.MatkMax	= MobDataAccesser.GetParam(M_V_MATKMAX,	MobID)
	MobState.MatkMin	= MobDataAccesser.GetParam(M_V_MATKMIN,	MobID)
	MobState.MdefDiv	= MobDataAccesser.GetParam(M_V_MDEFDIV,	MobID)
	MobState.MdefSub	= MobDataAccesser.GetParam(M_V_MDEFSUB,	MobID)
	
	MobState.Atk			= MobState.AtkMax
	MobState.Matk		= MobState.MatkMax
	MobState.Hit			= 0
	MobState.Critical	= 0
	MobState.Def			= MobState.DefDiv
	MobState.Mdef		= MobState.MdefDiv
	MobState.Flee		= 0
	MobState.Aspd		= MobDataAccesser.GetParam(M_V_ASPD,		MobID)
	
	MobState.Str			= 0
	MobState.Dex		= 0
	MobState.Int			= 0
	MobState.Vit			= MobState.DefSub
	MobState.Luk			= 0
	
	--ȉMob
	MobState.NeedHit	= MobDataAccesser.GetParam(M_V_NEEDHIT,		MobID)
	MobState.NeedFlee	= MobDataAccesser.GetParam(M_V_NEEDFLEE,	MobID)
	MobState.Race		= MobDataAccesser.GetParam(M_V_RACE,			MobID)
	MobState.Element	= MobDataAccesser.GetParam(M_V_ATT,			MobID)
	MobState.Size		= MobDataAccesser.GetParam(M_V_SIZE,			MobID)
	MobState.Speed		= MobDataAccesser.GetParam(M_V_MOVESPD,	MobID)
	
	MobState.BaseXP	= MobDataAccesser.GetParam(M_V_BASEEXP,	MobID)
	MobState.JobXP		= MobDataAccesser.GetParam(M_V_JOBEXP,		MobID)
	
	if MobDataAccesser.GetParam(M_V_LOOT,		MobID)==1 then
		MobState.Loot = true
	else
		MobState.Loot = false
	end
	
	if MobDataAccesser.GetParam(M_V_LINK,		MobID) == 1 then
		MobState.Link = true
	else
		MobState.Link = false
	end
	
	if MobDataAccesser.GetParam(M_V_SPELL,	MobID) == 1 then
		MobState.Spel = true
	else
		MobState.Spel = false
	end
	
	if MobDataAccesser.GetParam(M_V_ACTIVE,	MobID) == 1 then
		MobState.Active = true
	else
		MobState.Active = false
	end
	
	if MobDataAccesser.GetParam(M_V_SPLASH,	MobID) == 1 then
		MobState.Splash = true
	else
		MobState.Splash = false
	end
	
	if MobDataAccesser.GetParam(M_V_LONGRANGE,	MobID) == 1 then
		MobState.Long = true
	else
		MobState.Long = false
	end
	
	return MobState 
end

--[[ Private ]]
function MobDataAccesser.GetParam(DataType, ActorID)
	local Param =  GetMobData(DataType, ActorID)
	
	if Param == nil then
		assert(Param)
		return 0
	else
		return Param
	end
end
