local GetTickTest			= 500000000
local GetTickTestCount	= 0

local GetActorsTest = {
	12829,
	1002,			--z Monster
	1049,			--z Monster
	1216,			--z Monster
	1302,			--z Monster
	
	100000,		--z Owner
	
	100010,		--z Friend
	
	100100,		--z Unknown
	100101,		--z Unknown
	
	101000,		--z Homn
	
	110000,		--z Plant
}

local MotionTest = {
	[12829] = 0,
	[1002] = 1,	--z Monster
	[1049] = 2,	--z Monster
	[1216] = 3,--z Monster
	[1302] = 4,		--z Monster
	
	[100000] = 5,		--z Owner
	
	[100010] = 6,		--z Friend
	
	[100100] = 7,	--z Unknown
	[100101] = 8,		--z Unknown
	
	[101000] = 9,		--z Homn

	[110000] = 0,	--z Plant
}

local PositionTest = {
	[12829]	  = {4, 12},
	[1002] = {4, 13},		--z Monster
	[1049] = {4, 10},		--z Monster
	[1216] = {6, 14},		--z Monster
	[1302] = {7, 12},		--z Monster
	
	[100000] = {20, 25},		--z Owner
	
	[100010] = {14, 9},		--z Friend
	
	[100100] = {13, 17},		--z Unknown
	[100101] = {15, 17},		--z Unknown
	
	[101000] = {16, 11},		--z Homn
	
	[110000] = {12, 17},		--z Plant
}

--[[
O
X
W
 U UV
U
T
S
R
Q
gP
O
 enX
lW
oV
U
T
S
R
Q
P
P Q R S T U V W X O P Q R S T U V W X O
]]

local TargetTest = {
	[12829] = 1002,
	[1002] = 100000,	--z Monster
	[1049] = 12829,		--z Monster
	[1216] = 100000,	--z Monster
	[1302] = 100010,	--z Monster
	
	[100000] = 1002,	--z Owner
	
	[100010] = 1216,		--z Friend
	
	[100100] = 1302,	--z Unknown
	[100101] = 1302,	--z Unknown
	
	[101000] = 1002,	--z Homn
	
	[110000] = 1002,	--z Plant
}

local HomunTypeTest = {
	[12829] = 1,
	
	[1002]=1002,			--z Monster
	[1049]=1049,			--z Monster
	[1216]=1216,			--z Monster
	[1302]=1302,			--z Monster
	
	[100000] = 1,
	
	[100010] = 2,
	
	[100100] = 3,
	[100101] = 3,
	
	[101000] = 13000,
	
	[110000] = 5000,
	
}

function GetVMotionTest(ActorID)
	return MotionTest[ActorID]
end 

function GetVPositionTest(ActorID)
	return unpack(PositionTest[ActorID])
end

function GetVTargetTest(ActorID)
	return TargetTest[ActorID]
end

function GetVHomunTypeTest(ActorID)
	return HomunTypeTest[ActorID]
end

function GetActors()
	return GetActorsTest
end

function GetV(Type, ActorID)
	if Type == V_MOTION then
		return GetVMotionTest(ActorID)
	end
	
	if Type == V_OWNER then
		return 100000
	end
	
	if Type == V_POSITION then
		return GetVPositionTest(ActorID)
	end
	
	if Type == V_TARGET then
		return GetVTargetTest(ActorID)
	end
	
	if Type == V_HOMUNTYPE then
		return GetVHomunTypeTest(ActorID)
	end
	
	if Type == V_MAXHP then
		if My~=nil then MyID=My.ID end
		if ActorID == MyID then
			return 1000
		else
			return 3000
		end
	end
	if Type == V_HP then
		if My~=nil then MyID=My.ID end
		if ActorID == MyID then
			return 800
		else
			return 2100
		end
	end
	
	if Type == V_MAXSP then
		if My~=nil then MyID=My.ID end
		if ActorID == MyID then
			return 100
		else
			return 200
		end
	end
	if Type == V_SP then
		if My~=nil then MyID=My.ID end
		if ActorID == MyID then
			return 50
		else
			return 120
		end
	end
	
end

function GetTick()
	GetTickTest = GetTickTest + 140
	
	return GetTickTest
end

function TraceAI(OutputString)
	print(OutputString)
end

function Move(myid, posX, posY)
	--print("    Move   X : " .. posX .. "  Y : " .. posY )
end

function IsMonster(ActorID)
	if 0 < ActorID and ActorID < 100000 then
		return 1
	else
		return 0
	end
end

function ActorTest()
	local lst = List.New()
	local acl = GetActors()
	
	for i, ActorID in pairs(acl) do
		List.Set(lst, ActorID, Actor.New(ActorID))
	end
	
	for i, Act in pairs(lst) do
		if type(Act)=="table" then
			Trace(Act.ID)
			Trace(lst[i])
		end
	end
end

function Attack(myid, Target)
	Trace("Attack : " .. Target )
end

function SkillObject(id, Level, Skill, Target)
	if SkillDataAccesser~=nil then
		local SkillData	= SkillDataAccesser.GetSkillData(Skill)
		local TargetData	= Finding.GetActorData(Target)
		Trace("Skill : " .. SkillData.Name .. "  " .. TargetData.Status.Name )
	end
end

function GetMsg(myid)
	return {}
end

function GetResMsg(myid)
	return {}
end
	